package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;
import java.util.Optional;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.EmpresaCieloLinkDAO;
import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.EmpresaCieloLinkConfig;

@Repository("empresaCieloLinkDAO")
public class EmpresaCieloLinkHibernateDAO extends GenericHibernateDAO<EmpresaCieloLinkConfig, Integer>
		implements EmpresaCieloLinkDAO {

	@Autowired
	public EmpresaCieloLinkHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
		setSessionFactory(factory);
	}

	@SuppressWarnings("unchecked")
	@Override
	public List<EmpresaCieloLinkConfig> obtenerTodos() {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

		return c.list();
	}

	@Override
	public Optional<EmpresaCieloLinkConfig> buscarPorEmpresa(Empresa empresa) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
		c.add(Restrictions.eq("empresa.empresaId", empresa.getEmpresaId()));

		return Optional.ofNullable((EmpresaCieloLinkConfig) c.uniqueResult());
	}
}
